package com.tzld.piaoquan.api.model.po.contentplatform;

import com.tzld.piaoquan.growth.common.utils.page.Page;
import java.util.ArrayList;
import java.util.List;

public class ContentPlatformGzhPlanVideoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    protected Page page;

    public ContentPlatformGzhPlanVideoExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setPage(Page page) {
        this.page=page;
    }

    public Page getPage() {
        return page;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andPlanIdIsNull() {
            addCriterion("plan_id is null");
            return (Criteria) this;
        }

        public Criteria andPlanIdIsNotNull() {
            addCriterion("plan_id is not null");
            return (Criteria) this;
        }

        public Criteria andPlanIdEqualTo(Long value) {
            addCriterion("plan_id =", value, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdNotEqualTo(Long value) {
            addCriterion("plan_id <>", value, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdGreaterThan(Long value) {
            addCriterion("plan_id >", value, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdGreaterThanOrEqualTo(Long value) {
            addCriterion("plan_id >=", value, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdLessThan(Long value) {
            addCriterion("plan_id <", value, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdLessThanOrEqualTo(Long value) {
            addCriterion("plan_id <=", value, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdIn(List<Long> values) {
            addCriterion("plan_id in", values, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdNotIn(List<Long> values) {
            addCriterion("plan_id not in", values, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdBetween(Long value1, Long value2) {
            addCriterion("plan_id between", value1, value2, "planId");
            return (Criteria) this;
        }

        public Criteria andPlanIdNotBetween(Long value1, Long value2) {
            addCriterion("plan_id not between", value1, value2, "planId");
            return (Criteria) this;
        }

        public Criteria andVideoIdIsNull() {
            addCriterion("video_id is null");
            return (Criteria) this;
        }

        public Criteria andVideoIdIsNotNull() {
            addCriterion("video_id is not null");
            return (Criteria) this;
        }

        public Criteria andVideoIdEqualTo(Long value) {
            addCriterion("video_id =", value, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdNotEqualTo(Long value) {
            addCriterion("video_id <>", value, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdGreaterThan(Long value) {
            addCriterion("video_id >", value, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdGreaterThanOrEqualTo(Long value) {
            addCriterion("video_id >=", value, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdLessThan(Long value) {
            addCriterion("video_id <", value, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdLessThanOrEqualTo(Long value) {
            addCriterion("video_id <=", value, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdIn(List<Long> values) {
            addCriterion("video_id in", values, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdNotIn(List<Long> values) {
            addCriterion("video_id not in", values, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdBetween(Long value1, Long value2) {
            addCriterion("video_id between", value1, value2, "videoId");
            return (Criteria) this;
        }

        public Criteria andVideoIdNotBetween(Long value1, Long value2) {
            addCriterion("video_id not between", value1, value2, "videoId");
            return (Criteria) this;
        }

        public Criteria andTitleIsNull() {
            addCriterion("title is null");
            return (Criteria) this;
        }

        public Criteria andTitleIsNotNull() {
            addCriterion("title is not null");
            return (Criteria) this;
        }

        public Criteria andTitleEqualTo(String value) {
            addCriterion("title =", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotEqualTo(String value) {
            addCriterion("title <>", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleGreaterThan(String value) {
            addCriterion("title >", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleGreaterThanOrEqualTo(String value) {
            addCriterion("title >=", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLessThan(String value) {
            addCriterion("title <", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLessThanOrEqualTo(String value) {
            addCriterion("title <=", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLike(String value) {
            addCriterion("title like", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotLike(String value) {
            addCriterion("title not like", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleIn(List<String> values) {
            addCriterion("title in", values, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotIn(List<String> values) {
            addCriterion("title not in", values, "title");
            return (Criteria) this;
        }

        public Criteria andTitleBetween(String value1, String value2) {
            addCriterion("title between", value1, value2, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotBetween(String value1, String value2) {
            addCriterion("title not between", value1, value2, "title");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdIsNull() {
            addCriterion("custom_title_id is null");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdIsNotNull() {
            addCriterion("custom_title_id is not null");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdEqualTo(Long value) {
            addCriterion("custom_title_id =", value, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdNotEqualTo(Long value) {
            addCriterion("custom_title_id <>", value, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdGreaterThan(Long value) {
            addCriterion("custom_title_id >", value, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdGreaterThanOrEqualTo(Long value) {
            addCriterion("custom_title_id >=", value, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdLessThan(Long value) {
            addCriterion("custom_title_id <", value, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdLessThanOrEqualTo(Long value) {
            addCriterion("custom_title_id <=", value, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdIn(List<Long> values) {
            addCriterion("custom_title_id in", values, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdNotIn(List<Long> values) {
            addCriterion("custom_title_id not in", values, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdBetween(Long value1, Long value2) {
            addCriterion("custom_title_id between", value1, value2, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIdNotBetween(Long value1, Long value2) {
            addCriterion("custom_title_id not between", value1, value2, "customTitleId");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIsNull() {
            addCriterion("custom_title is null");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIsNotNull() {
            addCriterion("custom_title is not null");
            return (Criteria) this;
        }

        public Criteria andCustomTitleEqualTo(String value) {
            addCriterion("custom_title =", value, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleNotEqualTo(String value) {
            addCriterion("custom_title <>", value, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleGreaterThan(String value) {
            addCriterion("custom_title >", value, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleGreaterThanOrEqualTo(String value) {
            addCriterion("custom_title >=", value, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleLessThan(String value) {
            addCriterion("custom_title <", value, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleLessThanOrEqualTo(String value) {
            addCriterion("custom_title <=", value, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleLike(String value) {
            addCriterion("custom_title like", value, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleNotLike(String value) {
            addCriterion("custom_title not like", value, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleIn(List<String> values) {
            addCriterion("custom_title in", values, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleNotIn(List<String> values) {
            addCriterion("custom_title not in", values, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleBetween(String value1, String value2) {
            addCriterion("custom_title between", value1, value2, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCustomTitleNotBetween(String value1, String value2) {
            addCriterion("custom_title not between", value1, value2, "customTitle");
            return (Criteria) this;
        }

        public Criteria andCoverIsNull() {
            addCriterion("cover is null");
            return (Criteria) this;
        }

        public Criteria andCoverIsNotNull() {
            addCriterion("cover is not null");
            return (Criteria) this;
        }

        public Criteria andCoverEqualTo(String value) {
            addCriterion("cover =", value, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverNotEqualTo(String value) {
            addCriterion("cover <>", value, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverGreaterThan(String value) {
            addCriterion("cover >", value, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverGreaterThanOrEqualTo(String value) {
            addCriterion("cover >=", value, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverLessThan(String value) {
            addCriterion("cover <", value, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverLessThanOrEqualTo(String value) {
            addCriterion("cover <=", value, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverLike(String value) {
            addCriterion("cover like", value, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverNotLike(String value) {
            addCriterion("cover not like", value, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverIn(List<String> values) {
            addCriterion("cover in", values, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverNotIn(List<String> values) {
            addCriterion("cover not in", values, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverBetween(String value1, String value2) {
            addCriterion("cover between", value1, value2, "cover");
            return (Criteria) this;
        }

        public Criteria andCoverNotBetween(String value1, String value2) {
            addCriterion("cover not between", value1, value2, "cover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdIsNull() {
            addCriterion("custom_cover_id is null");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdIsNotNull() {
            addCriterion("custom_cover_id is not null");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdEqualTo(Long value) {
            addCriterion("custom_cover_id =", value, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdNotEqualTo(Long value) {
            addCriterion("custom_cover_id <>", value, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdGreaterThan(Long value) {
            addCriterion("custom_cover_id >", value, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdGreaterThanOrEqualTo(Long value) {
            addCriterion("custom_cover_id >=", value, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdLessThan(Long value) {
            addCriterion("custom_cover_id <", value, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdLessThanOrEqualTo(Long value) {
            addCriterion("custom_cover_id <=", value, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdIn(List<Long> values) {
            addCriterion("custom_cover_id in", values, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdNotIn(List<Long> values) {
            addCriterion("custom_cover_id not in", values, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdBetween(Long value1, Long value2) {
            addCriterion("custom_cover_id between", value1, value2, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIdNotBetween(Long value1, Long value2) {
            addCriterion("custom_cover_id not between", value1, value2, "customCoverId");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIsNull() {
            addCriterion("custom_cover is null");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIsNotNull() {
            addCriterion("custom_cover is not null");
            return (Criteria) this;
        }

        public Criteria andCustomCoverEqualTo(String value) {
            addCriterion("custom_cover =", value, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverNotEqualTo(String value) {
            addCriterion("custom_cover <>", value, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverGreaterThan(String value) {
            addCriterion("custom_cover >", value, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverGreaterThanOrEqualTo(String value) {
            addCriterion("custom_cover >=", value, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverLessThan(String value) {
            addCriterion("custom_cover <", value, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverLessThanOrEqualTo(String value) {
            addCriterion("custom_cover <=", value, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverLike(String value) {
            addCriterion("custom_cover like", value, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverNotLike(String value) {
            addCriterion("custom_cover not like", value, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverIn(List<String> values) {
            addCriterion("custom_cover in", values, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverNotIn(List<String> values) {
            addCriterion("custom_cover not in", values, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverBetween(String value1, String value2) {
            addCriterion("custom_cover between", value1, value2, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverNotBetween(String value1, String value2) {
            addCriterion("custom_cover not between", value1, value2, "customCover");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeIsNull() {
            addCriterion("custom_cover_type is null");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeIsNotNull() {
            addCriterion("custom_cover_type is not null");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeEqualTo(Integer value) {
            addCriterion("custom_cover_type =", value, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeNotEqualTo(Integer value) {
            addCriterion("custom_cover_type <>", value, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeGreaterThan(Integer value) {
            addCriterion("custom_cover_type >", value, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("custom_cover_type >=", value, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeLessThan(Integer value) {
            addCriterion("custom_cover_type <", value, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeLessThanOrEqualTo(Integer value) {
            addCriterion("custom_cover_type <=", value, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeIn(List<Integer> values) {
            addCriterion("custom_cover_type in", values, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeNotIn(List<Integer> values) {
            addCriterion("custom_cover_type not in", values, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeBetween(Integer value1, Integer value2) {
            addCriterion("custom_cover_type between", value1, value2, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andCustomCoverTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("custom_cover_type not between", value1, value2, "customCoverType");
            return (Criteria) this;
        }

        public Criteria andVideoIsNull() {
            addCriterion("video is null");
            return (Criteria) this;
        }

        public Criteria andVideoIsNotNull() {
            addCriterion("video is not null");
            return (Criteria) this;
        }

        public Criteria andVideoEqualTo(String value) {
            addCriterion("video =", value, "video");
            return (Criteria) this;
        }

        public Criteria andVideoNotEqualTo(String value) {
            addCriterion("video <>", value, "video");
            return (Criteria) this;
        }

        public Criteria andVideoGreaterThan(String value) {
            addCriterion("video >", value, "video");
            return (Criteria) this;
        }

        public Criteria andVideoGreaterThanOrEqualTo(String value) {
            addCriterion("video >=", value, "video");
            return (Criteria) this;
        }

        public Criteria andVideoLessThan(String value) {
            addCriterion("video <", value, "video");
            return (Criteria) this;
        }

        public Criteria andVideoLessThanOrEqualTo(String value) {
            addCriterion("video <=", value, "video");
            return (Criteria) this;
        }

        public Criteria andVideoLike(String value) {
            addCriterion("video like", value, "video");
            return (Criteria) this;
        }

        public Criteria andVideoNotLike(String value) {
            addCriterion("video not like", value, "video");
            return (Criteria) this;
        }

        public Criteria andVideoIn(List<String> values) {
            addCriterion("video in", values, "video");
            return (Criteria) this;
        }

        public Criteria andVideoNotIn(List<String> values) {
            addCriterion("video not in", values, "video");
            return (Criteria) this;
        }

        public Criteria andVideoBetween(String value1, String value2) {
            addCriterion("video between", value1, value2, "video");
            return (Criteria) this;
        }

        public Criteria andVideoNotBetween(String value1, String value2) {
            addCriterion("video not between", value1, value2, "video");
            return (Criteria) this;
        }

        public Criteria andPageUrlIsNull() {
            addCriterion("page_url is null");
            return (Criteria) this;
        }

        public Criteria andPageUrlIsNotNull() {
            addCriterion("page_url is not null");
            return (Criteria) this;
        }

        public Criteria andPageUrlEqualTo(String value) {
            addCriterion("page_url =", value, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlNotEqualTo(String value) {
            addCriterion("page_url <>", value, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlGreaterThan(String value) {
            addCriterion("page_url >", value, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlGreaterThanOrEqualTo(String value) {
            addCriterion("page_url >=", value, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlLessThan(String value) {
            addCriterion("page_url <", value, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlLessThanOrEqualTo(String value) {
            addCriterion("page_url <=", value, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlLike(String value) {
            addCriterion("page_url like", value, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlNotLike(String value) {
            addCriterion("page_url not like", value, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlIn(List<String> values) {
            addCriterion("page_url in", values, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlNotIn(List<String> values) {
            addCriterion("page_url not in", values, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlBetween(String value1, String value2) {
            addCriterion("page_url between", value1, value2, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andPageUrlNotBetween(String value1, String value2) {
            addCriterion("page_url not between", value1, value2, "pageUrl");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdIsNull() {
            addCriterion("root_source_id is null");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdIsNotNull() {
            addCriterion("root_source_id is not null");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdEqualTo(String value) {
            addCriterion("root_source_id =", value, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdNotEqualTo(String value) {
            addCriterion("root_source_id <>", value, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdGreaterThan(String value) {
            addCriterion("root_source_id >", value, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdGreaterThanOrEqualTo(String value) {
            addCriterion("root_source_id >=", value, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdLessThan(String value) {
            addCriterion("root_source_id <", value, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdLessThanOrEqualTo(String value) {
            addCriterion("root_source_id <=", value, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdLike(String value) {
            addCriterion("root_source_id like", value, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdNotLike(String value) {
            addCriterion("root_source_id not like", value, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdIn(List<String> values) {
            addCriterion("root_source_id in", values, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdNotIn(List<String> values) {
            addCriterion("root_source_id not in", values, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdBetween(String value1, String value2) {
            addCriterion("root_source_id between", value1, value2, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andRootSourceIdNotBetween(String value1, String value2) {
            addCriterion("root_source_id not between", value1, value2, "rootSourceId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdIsNull() {
            addCriterion("experiment_id is null");
            return (Criteria) this;
        }

        public Criteria andExperimentIdIsNotNull() {
            addCriterion("experiment_id is not null");
            return (Criteria) this;
        }

        public Criteria andExperimentIdEqualTo(String value) {
            addCriterion("experiment_id =", value, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdNotEqualTo(String value) {
            addCriterion("experiment_id <>", value, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdGreaterThan(String value) {
            addCriterion("experiment_id >", value, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdGreaterThanOrEqualTo(String value) {
            addCriterion("experiment_id >=", value, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdLessThan(String value) {
            addCriterion("experiment_id <", value, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdLessThanOrEqualTo(String value) {
            addCriterion("experiment_id <=", value, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdLike(String value) {
            addCriterion("experiment_id like", value, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdNotLike(String value) {
            addCriterion("experiment_id not like", value, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdIn(List<String> values) {
            addCriterion("experiment_id in", values, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdNotIn(List<String> values) {
            addCriterion("experiment_id not in", values, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdBetween(String value1, String value2) {
            addCriterion("experiment_id between", value1, value2, "experimentId");
            return (Criteria) this;
        }

        public Criteria andExperimentIdNotBetween(String value1, String value2) {
            addCriterion("experiment_id not between", value1, value2, "experimentId");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdIsNull() {
            addCriterion("create_account_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdIsNotNull() {
            addCriterion("create_account_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdEqualTo(Long value) {
            addCriterion("create_account_id =", value, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdNotEqualTo(Long value) {
            addCriterion("create_account_id <>", value, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdGreaterThan(Long value) {
            addCriterion("create_account_id >", value, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_account_id >=", value, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdLessThan(Long value) {
            addCriterion("create_account_id <", value, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdLessThanOrEqualTo(Long value) {
            addCriterion("create_account_id <=", value, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdIn(List<Long> values) {
            addCriterion("create_account_id in", values, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdNotIn(List<Long> values) {
            addCriterion("create_account_id not in", values, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdBetween(Long value1, Long value2) {
            addCriterion("create_account_id between", value1, value2, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateAccountIdNotBetween(Long value1, Long value2) {
            addCriterion("create_account_id not between", value1, value2, "createAccountId");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampIsNull() {
            addCriterion("create_timestamp is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampIsNotNull() {
            addCriterion("create_timestamp is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampEqualTo(Long value) {
            addCriterion("create_timestamp =", value, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampNotEqualTo(Long value) {
            addCriterion("create_timestamp <>", value, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampGreaterThan(Long value) {
            addCriterion("create_timestamp >", value, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampGreaterThanOrEqualTo(Long value) {
            addCriterion("create_timestamp >=", value, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampLessThan(Long value) {
            addCriterion("create_timestamp <", value, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampLessThanOrEqualTo(Long value) {
            addCriterion("create_timestamp <=", value, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampIn(List<Long> values) {
            addCriterion("create_timestamp in", values, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampNotIn(List<Long> values) {
            addCriterion("create_timestamp not in", values, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampBetween(Long value1, Long value2) {
            addCriterion("create_timestamp between", value1, value2, "createTimestamp");
            return (Criteria) this;
        }

        public Criteria andCreateTimestampNotBetween(Long value1, Long value2) {
            addCriterion("create_timestamp not between", value1, value2, "createTimestamp");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}